/*************************************************************************
*
*  File Name   : Devcaps.h
*
*  Description : This file contains the definitions used by the DEVCAPS
*                sample application.
*                
*  Concepts    : None.
*               
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.                                                    *
*
************************************************************************/

#define NUM_HELP_LINES   55

#define MaxDevices      21

#define ID_ENTRYFIELD   258
#define ID_COMMANDS     259
#define ID_EXITPROGRAM  261
#define ID_MESSAGEBOX   263
#define ID_BITMAP       264
#define ID_PRODINFO     265
#define ID_DEVICE_NOTEBOOK 266
#define IDM_HELPDLG     275

#define ID_CAPS_LISTBOX   350
#define ID_HELP_LISTBOX  999

/* defines for MCI string commands */
#define MCI_STRING_LENGTH                 128
#define MCI_ERROR_STRING_LENGTH           128
#define MCI_RETURN_STRING_LENGTH          128
#define MaxStringCommands                  13

/* Dialogs */
#define ID_MYDIALOG                1
#define ID_DEVICEDIALOG            291
#define ID_HELP_INFO_DLG           292
#define ID_HELPDIALOG              293

/* Strings */
//#define ID_RESPONSE                990

/* Dialog Component ID's */
#define ID_DEVICETYPE              401



/**************************************************************/
/* Defines for Videodisc and Overlay Device Specific Devcaps. */
/* The defines reference the define base and the beginning of */
/* the group of specific commands in MMSYSTEM.H.              */
/**************************************************************/

    /*************************************************/
    /* MCI_GETDEVCAPS item values for Videodisc      */
    /*************************************************/
#define VdiscCmds_Begin  MCI_VD_GETDEVCAPS_CAN_REVERSE   /* first command base */
#define VdiscCmds_End    MCI_VD_GETDEVCAPS_MAXIMUM_RATE  /* last command base */


   /*************************************************/
   /* MCI_GETDEVCAPS item values for Video Overlay  */
   /*************************************************/
#define OvlyCmds_Begin   MCI_OVLY_GETDEVCAPS_CAN_STRETCH       /* first command base */
#define OvlyCmds_End     MCI_OVLY_GETDEVCAPS_OVERLAY_GRAPHICS  /* last command base */

/* Type definitions sections */

typedef struct {
      CHAR szTabID[MAX_DEVICE_NAME];       /* the device type name */
      HWND hwndPageDlg;                    /* device page hwnd */
      WORD wDeviceType;                    /* device type number */
      CHAR szInstallName[MAX_DEVICE_NAME]; /* device install name */
      CHAR szProductInfo[MAX_PRODINFO];    /* device product info */
      BOOL fDevSelect;                     /* has this dev been selected */
} MCI_DEVCAPS_DEVICE;

typedef struct {
   CHAR szDevTypeName[MAX_DEVICE_NAME];    /* Device type name */
   WORD wDeviceType;                       /* Device type number */
} MCI_INSTALLED_DEVICE;


typedef struct
{
   CHAR mciStrCommands[MCI_STRING_LENGTH];
} SendString;


/* String Table defines for Help Information Text */

#define         ID_HELP_TEXT_LINE_1             1000
#define         ID_HELP_TEXT_LINE_2             1001 
#define         ID_HELP_TEXT_LINE_3             1002 
#define         ID_HELP_TEXT_LINE_4             1003 
#define         ID_HELP_TEXT_LINE_5             1004 
#define         ID_HELP_TEXT_LINE_6             1005 
#define         ID_HELP_TEXT_LINE_7             1006 
#define         ID_HELP_TEXT_LINE_8             1007 
#define         ID_HELP_TEXT_LINE_9             1008 
#define         ID_HELP_TEXT_LINE_10            1009 
#define         ID_HELP_TEXT_LINE_11            1010 
#define         ID_HELP_TEXT_LINE_12            1011 
#define         ID_HELP_TEXT_LINE_13            1012 
#define         ID_HELP_TEXT_LINE_14            1013
#define         ID_HELP_TEXT_LINE_15            1014 
#define         ID_HELP_TEXT_LINE_16            1015 
#define         ID_HELP_TEXT_LINE_17            1016
#define         ID_HELP_TEXT_LINE_18            1017
#define         ID_HELP_TEXT_LINE_19            1018 
#define         ID_HELP_TEXT_LINE_20            1019 
#define         ID_HELP_TEXT_LINE_21            1020 
#define         ID_HELP_TEXT_LINE_22            1021 
#define         ID_HELP_TEXT_LINE_23            1022 
#define         ID_HELP_TEXT_LINE_24            1023 
#define         ID_HELP_TEXT_LINE_25            1024 
#define         ID_HELP_TEXT_LINE_26            1025 
#define         ID_HELP_TEXT_LINE_27            1026 
#define         ID_HELP_TEXT_LINE_28            1027 
#define         ID_HELP_TEXT_LINE_29            1028 
#define         ID_HELP_TEXT_LINE_30            1029 
#define         ID_HELP_TEXT_LINE_31            1030 
#define         ID_HELP_TEXT_LINE_32            1031 
#define         ID_HELP_TEXT_LINE_33            1032 
#define         ID_HELP_TEXT_LINE_34            1033 
#define         ID_HELP_TEXT_LINE_35            1034 
#define         ID_HELP_TEXT_LINE_36            1035 
#define         ID_HELP_TEXT_LINE_37            1036 
#define         ID_HELP_TEXT_LINE_38            1037 
#define         ID_HELP_TEXT_LINE_39            1038 
#define         ID_HELP_TEXT_LINE_40            1039 
#define         ID_HELP_TEXT_LINE_41            1040 
#define         ID_HELP_TEXT_LINE_42            1041 
#define         ID_HELP_TEXT_LINE_43            1042 
#define         ID_HELP_TEXT_LINE_44            1043 
#define         ID_HELP_TEXT_LINE_45            1044 
#define         ID_HELP_TEXT_LINE_46            1045 
#define         ID_HELP_TEXT_LINE_47            1046 
#define         ID_HELP_TEXT_LINE_48            1047 
#define         ID_HELP_TEXT_LINE_49            1048 
#define         ID_HELP_TEXT_LINE_50            1049 
#define         ID_HELP_TEXT_LINE_51            1050 
#define         ID_HELP_TEXT_LINE_52            1051 
#define         ID_HELP_TEXT_LINE_53            1052 
#define         ID_HELP_TEXT_LINE_54            1053 
#define         ID_HELP_TEXT_LINE_55            1054 

