//*****************************************************************************
//
// File Name: Vidview.h
//
// ****!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****
// ****************************************************************************
// *+*+* NOTE: This file contains both '//' style comments and "/*  */"   *+*+*
// **+**       style comments.  You will have to set the the /Ss+ compile *****
// *+*+*       option for this file to be compiled.                       *+*+*
// ****************************************************************************
// ****!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*****
//
// Description : This file contains the definitions used by the VIDVIEW
//               sample application.
//
// Copyright (C) 1992 IBM Corporation
//
//     DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
//     sample code created by IBM Corporation. This sample code is not
//     part of any standard or IBM product and is provided to you solely
//     for  the purpose of assisting you in the development of your
//     applications.  The code is provided "AS IS", without
//     warranty of any kind.  IBM shall not be liable for any damages
//     arising out of your use of the sample code, even if they have been
//     advised of the possibility of such damages.                                                    *
//
//*****************************************************************************

//-----------------------------------------------------------------------------
// Typedefs and associated defines....
//-----------------------------------------------------------------------------
// This structure keeps track of player values...
typedef struct _tagPlayerInfo
   {
   CHAR     szDeviceName  [ 20 ] ;
   CHAR     szDeviceAlias [ 20 ] ;
   WORD     wDeviceID            ;
   BOOL     fOwnDevice           ;
   BOOL     fAudioAllOn          ;
   BOOL     fInfoDisplayOn       ;
   BOOL     fDoorClosed          ;
   BOOL     fSpunUp              ;
   } PLAYERINFO ;

typedef PLAYERINFO *PPLAYERINFO ;


//Defines...
#define MAX_PLAYERS      1
#define MAX_OVERLAYS     1
#define MAX_VIDEOWINDOWINFOS 3

// This structure keeps track of values for a particular video input (1,2,3)...
typedef struct _tagVideoWindowInfo
   {
   BOOL     fInitialized           ;

   LONG     InputType              ;

   LONG     Style                  ;
   WORD     ActionMode             ;
   LONG     Readout                ;
   LONG     SaveReadout            ;
   COLOR    clrClientBG            ;
   COLOR    clrClientFG            ;
   RECTL    rclClient              ;
   RECTL    rclClientOnDesktop     ;
   RECTL    rclMinClient           ;
   RECTL    rclFrame               ;
   RECTL    rclFrameOnDesktop      ;

   BOOL     fSrcControlDlgActive   ;
   RECTL    rclSrcControlDlg       ;

   PRECTL   prclSrcRects           ;
   PRECTL   prclDstRects           ;
   PSZ      *ppszWindowStrings     ;

   RECTL    rclCurDst              ;
   RECTL    rclMaxDst              ;
   RECTL    rclMinDst              ;

   RECTL    rclCurSrc              ;
   RECTL    rclMaxSrc              ;
   RECTL    rclMinSrc              ;

   LONG     SrcAspectX             ;
   LONG     SrcAspectY             ;

   BOOL     fAspectKeepX           ;
   BOOL     fSrcZoomXLimitsMaxSize ;
   LONG     SrcZoomLoBound         ;
   LONG     SrcZoomHiBound         ;
   LONG     SrcZoomPageIncr        ;
   LONG     SrcZoomLineIncr        ;
   LONG     DeltaLineHorzPan       ;
   LONG     DeltaPageHorzPan       ;
   LONG     DeltaLineVertPan       ;
   LONG     DeltaPageVertPan       ;
   LONG     DeltaLineHorzZoom      ;
   LONG     DeltaPageHorzZoom      ;
   LONG     DeltaLineVertZoom      ;
   LONG     DeltaPageVertZoom      ;
   LONG     SrcHSBLength           ;
   LONG     SrcHSBThumbSize        ;
   LONG     SrcVSBLength           ;
   LONG     SrcVSBThumbSize        ;
   BOOL     fZoom                  ;
   LONG     HeightDifference       ;
   POINTL   OrgCyForZoom           ;
   POINTL   OrgTextForZoom         ;
   POINTL   OrgCyForStretch        ;
   POINTL   OrgTextForStretch      ;
   } VIDEOWINDOWINFO ;

typedef VIDEOWINDOWINFO *PVIDEOWINDOWINFO ;

// This structure is used for displaying values...
typedef struct _tagDisplayValuesInfo
   {
   PBYTE    pbNormalLabel ;
   PBYTE    pbNormalValue ;
   PBYTE    pbTerseLabel  ;
   PBYTE    pbTerseValue  ;
   PRECTL   prclValues    ;
   BOOL     fDisplay      ;
   } DISPLAYVALUESINFO ;

typedef DISPLAYVALUESINFO *PDISPLAYVALUESINFO ;
//typedef struct _tagDisplayValuesInfo
//   {
//   PBYTE    pbRegularFormat   ;
//   PBYTE    pbTerseFormat   ;
//   PRECTL   prclValues ;
//   BOOL     fDisplay   ;
//   } DISPLAYVALUESINFO ;

// This structure holds general program values...
typedef struct _tagAPPLICATIONINFO
   {
   BOOL              fOwnDevice                               ;
   BOOL              fInitializing                            ;
   BOOL              fMinimized                               ;
   BOOL              fSettingFramePos                         ;
   CHAR              szOverlayDeviceName  [ 20 ]              ;
   CHAR              szOverlayDeviceAlias [ 20 ]              ;
   HWND              hwndSourceDlg                            ;
   HWND              hwndSeekDlg                              ;
   LONG              SizeBorderCx                             ;
   LONG              SizeBorderCy                             ;
   LONG              SeekFrame                                ;
   LONG              VideoInput                               ;
   WORD              wOverlayDeviceID                         ;
   RECTL             rclScreen                                ;
   RECTL             rclMinClient                             ;
   LONG              NormalLabelWidth                         ;
   LONG              NormalValueWidth                         ;
   LONG              TerseLabelWidth                          ;
   LONG              TerseValueWidth                          ;
   VIDEOWINDOWINFO   vwiInfo                                  ;
   VIDEOWINDOWINFO   aviVideoSources [ MAX_VIDEOWINDOWINFOS ] ;
   } APPLICATIONINFO ;

typedef APPLICATIONINFO *PAPPLICATIONINFO ;


// Defines for wActionMode....
#define VVK_AM_NONE                         0
#define VVK_AM_MAINTAIN_CLIENT_ASPECT_RATIO 1
#define VVK_AM_ADJUST_SOURCE_AREA           2

// Defines for Readout...
#define VVK_RO_NONE        0
#define VVK_RO_WHITE       1
#define VVK_RO_YELLOW      2
#define VVK_RO_CYAN        3
#define VVK_RO_BLACK       4

// Defines for pvi->InputType
#define VVK_IT_NONE             0
#define VVK_IT_NTSC             1
#define VVK_IT_PAL              2

//-----------------------------------------------------------------------------
// Misc. defines....
//-----------------------------------------------------------------------------
// Max and min source and destination extents...
#define VVK_SRC_CX_MAX      706
#define VVK_SRC_CX_MIN        4
#define VVK_SRC_CY_MAX_NTSC 484
#define VVK_SRC_CY_MAX_PAL  564
#define VVK_SRC_CY_MIN        1

#define VVK_DST_CX_MAX      688
#define VVK_DST_CX_MIN        4
#define VVK_DST_CY_MAX_NTSC 480
#define VVK_DST_CY_MAX_PAL  548
#define VVK_DST_CY_MIN        1

// More defines...
#define ID_TIMER     1                 // Timer id for logo panel...
#define ID_STATIC    1                 // Child video window...
#define ID_MAINWND   1                 // Main window...

#define RETURN_ERROR         1         // Return value for exit
#define BEEP_WARN_FREQ      60         // Frequency of warning beep
#define BEEP_WARN_DUR      100         // Duration of warning beep
#define IDM_EXIT           110

#define MMCONTROLS_DLLNAME    "MMCTL"

// Coordinates of text rectangle within client window...
#define VVK_DR_XLEFT      10
#define VVK_DR_XRIGHT     285
#define VVK_DR_YBOTTOM    70
#define VVK_DR_YTOP       85


//-----------------------------------------------------------------------------
// Defines for MENUS...
//-----------------------------------------------------------------------------
// VIDEO INPUT submenu...
#define IDM_VIDEO_INPUT             330
#define IDM_VID_INPUT_1             331
#define IDM_VID_INPUT_2             332
#define IDM_VID_INPUT_3             333

// OVERLAY menu...
#define IDM_OVERLAY                               500
#define IDM_OVLY_MAINTAIN_CLIENT_ASPECT_RATIO     510
#define IDM_OVLY_ADJUST_SOURCE_AREA               520

// PLAYER menu
#define IDM_VDP                     600
#define IDM_VDP_OPEN_DEVICE         601
#define IDM_VDP_PLAY_FORWARD        602
#define IDM_VDP_PLAY_REVERSE        603
#define IDM_VDP_PLAY_FROM_TO        604
#define IDM_VDP_STOP                605
#define IDM_VDP_SEEK                606
#define IDM_VDP_STEP                607
#define IDM_VDP_INFO_DISPLAY        608
#define IDM_VDP_AUDIO               609
#define IDM_VDP_STATUS              610
#define IDM_VDP_SPIN                611
#define IDM_VDP_CLOSE_DEVICE        612
#define IDM_VDP_DOOR                613

// OPTIONS menu...
#define IDM_OPTIONS                 300

// READOUT ACTIVE menu item
#define IDM_RDT_ACTIVE              310

// READOUT COLOR submenu
#define IDM_READOUT_COLORS          370
#define IDM_RDTCLR_NONE             371
#define IDM_RDTCLR_WHITE            372
#define IDM_RDTCLR_YELLOW           373
#define IDM_RDTCLR_CYAN             374
#define IDM_RDTCLR_BLACK            375

// VIDEO WINDOW NTSC submenu...
#define IDM_VDW_CHILD                   7001
#define IDM_VDW_CLIENT_FULL_EXTENT      7002
#define IDM_VDW_CLIENT_04TH_EXTENT      7003
#define IDM_VDW_CLIENT_16TH_EXTENT      7004
#define IDM_VDW_CLIENT_64TH_EXTENT      7005
#define IDM_VDW_CLIENT_ARBITRARY_1      7006
#define IDM_VDW_CLIENT_ARBITRARY_2      7007
#define IDM_VDW_CLIENT_ARBITRARY_3      7008
#define IDM_VDW_MAIN                    7009

// HELP menu...
#define IDM_HELP                         700
#define IDM_HELPITEM                     710
#define IDM_ABOUT                        720

// MESSAGEBOX DIALOG BOX DEFINITIONS...
#define ID_MESSAGEBOX                   2000

// PRODINFO DIALOG BOX DEFINITIONS...
#define ID_DLG_PRODINFO                 3000
#define ID_PRODTEXT1                    3001
#define ID_PRODTEXT2                    3002
#define ID_PRODTEXT3                    3003
#define ID_PRODBITMAP                   3004


// Definitions for source control dialog box...
#define ID_DLG_SOURCE_RECTANGLE  6000
#define ID_SRC_RCL_TEXT_GROUP    6010
#define ID_SRC_RCL_TEXT_CY       6020
#define ID_SRC_RCL_TEXT_X2_Y2    6030
#define ID_SRC_RCL_TEXT_X1_Y1    6040
#define ID_SRC_RCL_TEXT_CX       6050
#define ID_SRC_RCL_SETUP         6060
#define ID_SRC_RCL_ZOOMSTRETCH   6070
#define ID_SRC_RCL_PAN_HORZ      6080
#define ID_SRC_RCL_PAN_VERT      6090
#define ID_SRC_RCL_PAN_V_LABEL   6100
#define ID_SRC_RCL_PAN_H_LABEL   6110
#define ID_SRC_RCL_ZOOM_CONTROL  6120
#define ID_SRC_RCL_STRETCH_HORZ  6130
#define ID_SRC_RCL_STRETCH_VERT  6140

// Definitions for seek dialog box...
#define ID_DLG_SEEK              7500
#define ID_SEEK_ENTRY_FIELD      7501
#define ID_SEEK_OK               7502
#define ID_SEEK_CANCEL           7503
#define ID_SEEK_TEXT             7503

// Definitions for help dialog box...
#define ID_HELP_INFO_DLG         4900
#define ID_HELP_LISTBOX          4901

// String Table defines for Help Information Text
#define NUM_HELP_LINES           189

#define         ID_HELP_TEXT_LINE_01                5001
#define         ID_HELP_TEXT_LINE_02                5002
#define         ID_HELP_TEXT_LINE_03                5003
#define         ID_HELP_TEXT_LINE_04                5004
#define         ID_HELP_TEXT_LINE_05                5005
#define         ID_HELP_TEXT_LINE_06                5006
#define         ID_HELP_TEXT_LINE_07                5007
#define         ID_HELP_TEXT_LINE_08                5008
#define         ID_HELP_TEXT_LINE_09                5009
#define         ID_HELP_TEXT_LINE_10                5010
#define         ID_HELP_TEXT_LINE_11                5011
#define         ID_HELP_TEXT_LINE_12                5012
#define         ID_HELP_TEXT_LINE_13                5013
#define         ID_HELP_TEXT_LINE_14                5014
#define         ID_HELP_TEXT_LINE_15                5015
#define         ID_HELP_TEXT_LINE_16                5016
#define         ID_HELP_TEXT_LINE_17                5017
#define         ID_HELP_TEXT_LINE_18                5018
#define         ID_HELP_TEXT_LINE_19                5019
#define         ID_HELP_TEXT_LINE_20                5020
#define         ID_HELP_TEXT_LINE_21                5021
#define         ID_HELP_TEXT_LINE_22                5022
#define         ID_HELP_TEXT_LINE_23                5023
#define         ID_HELP_TEXT_LINE_24                5024
#define         ID_HELP_TEXT_LINE_25                5025
#define         ID_HELP_TEXT_LINE_26                5026
#define         ID_HELP_TEXT_LINE_27                5027
#define         ID_HELP_TEXT_LINE_28                5028
#define         ID_HELP_TEXT_LINE_29                5029
#define         ID_HELP_TEXT_LINE_30                5030
#define         ID_HELP_TEXT_LINE_31                5031
#define         ID_HELP_TEXT_LINE_32                5032
#define         ID_HELP_TEXT_LINE_33                5033
#define         ID_HELP_TEXT_LINE_34                5034
#define         ID_HELP_TEXT_LINE_35                5035
#define         ID_HELP_TEXT_LINE_36                5036
#define         ID_HELP_TEXT_LINE_37                5037
#define         ID_HELP_TEXT_LINE_38                5038
#define         ID_HELP_TEXT_LINE_39                5039
#define         ID_HELP_TEXT_LINE_40                5040
#define         ID_HELP_TEXT_LINE_41                5041
#define         ID_HELP_TEXT_LINE_42                5042
#define         ID_HELP_TEXT_LINE_43                5043
#define         ID_HELP_TEXT_LINE_44                5044
#define         ID_HELP_TEXT_LINE_45                5045
#define         ID_HELP_TEXT_LINE_46                5046
#define         ID_HELP_TEXT_LINE_47                5047
#define         ID_HELP_TEXT_LINE_48                5048
#define         ID_HELP_TEXT_LINE_49                5049
#define         ID_HELP_TEXT_LINE_50                5050
#define         ID_HELP_TEXT_LINE_51                5051
#define         ID_HELP_TEXT_LINE_52                5052
#define         ID_HELP_TEXT_LINE_53                5053
#define         ID_HELP_TEXT_LINE_54                5054
#define         ID_HELP_TEXT_LINE_55                5055
#define         ID_HELP_TEXT_LINE_56                5056
#define         ID_HELP_TEXT_LINE_57                5057
#define         ID_HELP_TEXT_LINE_58                5058
#define         ID_HELP_TEXT_LINE_59                5059
#define         ID_HELP_TEXT_LINE_60                5060
#define         ID_HELP_TEXT_LINE_61                5061
#define         ID_HELP_TEXT_LINE_62                5062
#define         ID_HELP_TEXT_LINE_63                5063
#define         ID_HELP_TEXT_LINE_64                5064
#define         ID_HELP_TEXT_LINE_65                5065
#define         ID_HELP_TEXT_LINE_66                5066
#define         ID_HELP_TEXT_LINE_67                5067
#define         ID_HELP_TEXT_LINE_68                5068
#define         ID_HELP_TEXT_LINE_69                5069
#define         ID_HELP_TEXT_LINE_70                5070
#define         ID_HELP_TEXT_LINE_71                5071
#define         ID_HELP_TEXT_LINE_72                5072
#define         ID_HELP_TEXT_LINE_73                5073
#define         ID_HELP_TEXT_LINE_74                5074
#define         ID_HELP_TEXT_LINE_75                5075
#define         ID_HELP_TEXT_LINE_76                5076
#define         ID_HELP_TEXT_LINE_77                5077
#define         ID_HELP_TEXT_LINE_78                5078
#define         ID_HELP_TEXT_LINE_79                5079
#define         ID_HELP_TEXT_LINE_80                5080
#define         ID_HELP_TEXT_LINE_81                5081
#define         ID_HELP_TEXT_LINE_82                5082
#define         ID_HELP_TEXT_LINE_83                5083
#define         ID_HELP_TEXT_LINE_84                5084
#define         ID_HELP_TEXT_LINE_85                5085
#define         ID_HELP_TEXT_LINE_86                5086
#define         ID_HELP_TEXT_LINE_87                5087
#define         ID_HELP_TEXT_LINE_88                5088
#define         ID_HELP_TEXT_LINE_89                5089
#define         ID_HELP_TEXT_LINE_90                5090
#define         ID_HELP_TEXT_LINE_91                5091
#define         ID_HELP_TEXT_LINE_92                5092
#define         ID_HELP_TEXT_LINE_93                5093
#define         ID_HELP_TEXT_LINE_94                5094
#define         ID_HELP_TEXT_LINE_95                5095
#define         ID_HELP_TEXT_LINE_96                5096
#define         ID_HELP_TEXT_LINE_97                5097
#define         ID_HELP_TEXT_LINE_98                5098
#define         ID_HELP_TEXT_LINE_99                5099
#define         ID_HELP_TEXT_LINE_100               5100
#define         ID_HELP_TEXT_LINE_101               5101
#define         ID_HELP_TEXT_LINE_102               5102
#define         ID_HELP_TEXT_LINE_103               5103
#define         ID_HELP_TEXT_LINE_104               5104
#define         ID_HELP_TEXT_LINE_105               5105
#define         ID_HELP_TEXT_LINE_106               5106
#define         ID_HELP_TEXT_LINE_107               5107
#define         ID_HELP_TEXT_LINE_108               5108
#define         ID_HELP_TEXT_LINE_109               5109
#define         ID_HELP_TEXT_LINE_110               5110
#define         ID_HELP_TEXT_LINE_111               5111
#define         ID_HELP_TEXT_LINE_112               5112
#define         ID_HELP_TEXT_LINE_113               5113
#define         ID_HELP_TEXT_LINE_114               5114
#define         ID_HELP_TEXT_LINE_115               5115
#define         ID_HELP_TEXT_LINE_116               5116
#define         ID_HELP_TEXT_LINE_117               5117
#define         ID_HELP_TEXT_LINE_118               5118
#define         ID_HELP_TEXT_LINE_119               5119
#define         ID_HELP_TEXT_LINE_120               5120
#define         ID_HELP_TEXT_LINE_121               5121
#define         ID_HELP_TEXT_LINE_122               5122
#define         ID_HELP_TEXT_LINE_123               5123
#define         ID_HELP_TEXT_LINE_124               5124
#define         ID_HELP_TEXT_LINE_125               5125
#define         ID_HELP_TEXT_LINE_126               5126
#define         ID_HELP_TEXT_LINE_127               5127
#define         ID_HELP_TEXT_LINE_128               5128
#define         ID_HELP_TEXT_LINE_129               5129
#define         ID_HELP_TEXT_LINE_130               5130
#define         ID_HELP_TEXT_LINE_131               5131
#define         ID_HELP_TEXT_LINE_132               5132
#define         ID_HELP_TEXT_LINE_133               5133
#define         ID_HELP_TEXT_LINE_134               5134
#define         ID_HELP_TEXT_LINE_135               5135
#define         ID_HELP_TEXT_LINE_136               5136
#define         ID_HELP_TEXT_LINE_137               5137
#define         ID_HELP_TEXT_LINE_138               5138
#define         ID_HELP_TEXT_LINE_139               5139
#define         ID_HELP_TEXT_LINE_140               5140
#define         ID_HELP_TEXT_LINE_141               5141
#define         ID_HELP_TEXT_LINE_142               5142
#define         ID_HELP_TEXT_LINE_143               5143
#define         ID_HELP_TEXT_LINE_144               5144
#define         ID_HELP_TEXT_LINE_145               5145
#define         ID_HELP_TEXT_LINE_146               5146
#define         ID_HELP_TEXT_LINE_147               5147
#define         ID_HELP_TEXT_LINE_148               5148
#define         ID_HELP_TEXT_LINE_149               5149
#define         ID_HELP_TEXT_LINE_150               5150
#define         ID_HELP_TEXT_LINE_151               5151
#define         ID_HELP_TEXT_LINE_152               5152
#define         ID_HELP_TEXT_LINE_153               5153
#define         ID_HELP_TEXT_LINE_154               5154
#define         ID_HELP_TEXT_LINE_155               5155
#define         ID_HELP_TEXT_LINE_156               5156
#define         ID_HELP_TEXT_LINE_157               5157
#define         ID_HELP_TEXT_LINE_158               5158
#define         ID_HELP_TEXT_LINE_159               5159
#define         ID_HELP_TEXT_LINE_160               5160
#define         ID_HELP_TEXT_LINE_161               5161
#define         ID_HELP_TEXT_LINE_162               5162
#define         ID_HELP_TEXT_LINE_163               5163
#define         ID_HELP_TEXT_LINE_164               5164
#define         ID_HELP_TEXT_LINE_165               5165
#define         ID_HELP_TEXT_LINE_166               5166
#define         ID_HELP_TEXT_LINE_167               5167
#define         ID_HELP_TEXT_LINE_168               5168
#define         ID_HELP_TEXT_LINE_169               5169
#define         ID_HELP_TEXT_LINE_170               5170
#define         ID_HELP_TEXT_LINE_171               5171
#define         ID_HELP_TEXT_LINE_172               5172
#define         ID_HELP_TEXT_LINE_173               5173
#define         ID_HELP_TEXT_LINE_174               5174
#define         ID_HELP_TEXT_LINE_175               5175
#define         ID_HELP_TEXT_LINE_176               5176
#define         ID_HELP_TEXT_LINE_177               5177
#define         ID_HELP_TEXT_LINE_178               5178
#define         ID_HELP_TEXT_LINE_179               5179
#define         ID_HELP_TEXT_LINE_180               5180
#define         ID_HELP_TEXT_LINE_181               5181
#define         ID_HELP_TEXT_LINE_182               5182
#define         ID_HELP_TEXT_LINE_183               5183
#define         ID_HELP_TEXT_LINE_184               5184
#define         ID_HELP_TEXT_LINE_185               5185
#define         ID_HELP_TEXT_LINE_186               5186
#define         ID_HELP_TEXT_LINE_187               5187
#define         ID_HELP_TEXT_LINE_188               5188
#define         ID_HELP_TEXT_LINE_189               5189
#define         ID_HELP_TEXT_LINE_190               5190

// Other string table defines...
#define         ID_SEEK_TEXT_LABEL                  5150

//-----------------------------------------------------------------------------
// Externs for data...
//-----------------------------------------------------------------------------
extern HAB     hab        ;             // VIDVIEW anchor block...
extern HMQ     hmq        ;             // VIDIVEW message queue...
extern HWND    hwndFrame  ;             // Frame window handle
extern HWND    hwndClient ;             // Client window handle
extern HWND    hwndNotify ;             // Window to receive MCI_NOTIFY notifications...
extern HWND    hwndChild  ;             // Child of client
extern HWND    hwndMenu   ;             // Handle for Menu
extern HMODULE hMMCTLDll  ;             // MMCTL.DLL handle
extern BOOL    fDoFill    ;
extern SZ      szFullScreenMessage []         ;
extern RECTL   arclSrcRectsForNTSCInput [ 8 ] ;
extern RECTL   arclSrcRectsForPALInput  [ 8 ] ;
extern RECTL   arclDstRectsForNTSCInput [ 8 ] ;
extern RECTL   arclDstRectsForPALInput  [ 8 ] ;
extern PSZ     apszWindowStringsForNTSC [ 9 ] ;
extern PSZ     apszWindowStringsForPAL  [ 9 ] ;


//-----------------------------------------------------------------------------
// MCI functions: These package MCI calls for easy debugging and readability.
//                Can be lifted as is for use in other code.
//
//    -- General functions
//    -- Overlay functions
//    -- Videodisc player functions
//-----------------------------------------------------------------------------
// General MCI functions
DWORD    OpenDevice    ( LPSTR lpstrDevName, LPSTR lpstrDevAlias, DWORD dwMciFlags, WORD *pwDeviceID) ;
DWORD    CloseDevice   ( WORD wDeviceID ) ;
DWORD    AcquireDevice ( WORD wDeviceID, DWORD dwExclusive ) ;
DWORD    ReleaseDevice ( WORD wDeviceID ) ;

// Overlay MCI functions...
DWORD    OvlGetDstRect     ( WORD wDeviceID, HWND hwndCallback, PRECTL prcl ) ;
DWORD    OvlGetSrcExtRect  ( WORD wDeviceID, HWND hwndCallback, DWORD *pdwXExtent, DWORD *pdwYExtent ) ;
DWORD    OvlGetSrcRect     ( WORD wDeviceID, HWND hwndCallback, PRECTL prcl ) ;
DWORD    OvlPutDstRect     ( WORD wDeviceID, PRECTL prcl, HWND hwndCallback ) ;
DWORD    OvlPutSrcRect     ( WORD wDeviceID, PRECTL prcl, HWND hwndCallback ) ;
DWORD    OvlSetInput       ( WORD wDeviceID, DWORD dwSourceNum, DWORD dwSourceType ) ;
DWORD    OvlSetVideoWindow ( WORD wDeviceID, HWND hwndAlternate ) ;


// Videodisc player MCI functions...
DWORD    VdpGetCustomStatus ( WORD wDeviceID, DWORD dwMciFlags, DWORD *pdwReturn ) ;
DWORD    VdpGetStatus  ( WORD wDeviceID, DWORD dwMciFlags, DWORD dwItem, DWORD *pdwReturn ) ;
DWORD    VdpPlay       ( WORD wDeviceID, BOOL fForward, DWORD dwFromFrame,  DWORD dwToFrame )  ;
DWORD    VdpSeek       ( WORD wDeviceID, LONG SeekFrame, DWORD dwMciFlags, HWND hwndCallback, WORD wUserParm ) ;
BOOL     VdpReady      ( WORD wDeviceID ) ;
DWORD    VdpSetAudio   ( WORD wDeviceID, DWORD dwMciFlags, DWORD dwAudio ) ;
DWORD    VdpSetDisplay ( WORD wDeviceID, DWORD dwMciFlags )  ;
DWORD    VdpSonySetEnd ( WORD wDeviceID, DWORD dwMciFlags, DWORD EndFrame ) ;
DWORD    VdpSpin       ( WORD wDeviceID, DWORD dwMciFlags ) ;
DWORD    VdpStop       ( WORD wDeviceID ) ;

//-----------------------------------------------------------------------------
// Device management functions:
//
// Fragments of these may be helpful in writing new code.
//
//    -- Overlay functions
//    -- Videodisc player functions
//
//-----------------------------------------------------------------------------
// Functions for managing overlay...
VOID     ApplyAspectRatio ( LONG XAspect, LONG YAspect, PRECTL prclIn, PRECTL prclOut, BOOL fAspectKeepX ) ;
VOID     BuildProRect ( PRECTL prclOld, PRECTL prclNew, PRECTL prclPro,
                        LONG AspectX, LONG AspectY,
                        LONG NewWidth, LONG NewHeight ) ;
BOOL     MapRectToProRect ( PRECTL prclOld, PRECTL prclNew, PRECTL prclPro,
                  LONG AspectX, LONG AspectY, LONG MinWidth, LONG MinHeight,
                  LONG MaxWidth, LONG MaxHeight ) ;

// Functions for managing videodisc player...
DWORD    ConvertColonizedToAscii ( DWORD dwFormat, DWORD dwColonized, PBYTE pbString ) ;
DWORD    ConvertDwordToAscii ( DWORD dwValue, PBYTE pbString ) ;
DWORD    DisplayVideodiscStatus ( WORD wDeviceID ) ;

//-----------------------------------------------------------------------------
//
// VIDVIEW general functions...
//
//-----------------------------------------------------------------------------
VOID     AddLengthToRect ( PRECTL prclInput, PRECTL prclResult, LONG Delta, BOOL fAddToWidth ) ;
VOID     ApplyStretchToRect ( PVIDEOWINDOWINFO pvi, PRECTL prclInput,PRECTL prclResult, LONG NewLength, BOOL fApplyToWidth ) ;
VOID     ApplyZoomToRect ( PVIDEOWINDOWINFO pvi, PRECTL prclInput,PRECTL prclResult,LONG NewLength1, BOOL fXLimitsMaxSize, LONG AspectX, LONG AspectY ) ;
BOOL     AttemptHorizontalPan ( HWND hwnd, MPARAM mp2, PVIDEOWINDOWINFO pvi ) ;
BOOL     AttemptStretch ( HWND hwnd, MPARAM mp2, PVIDEOWINDOWINFO pvi, BOOL fApplyToWidth ) ;
BOOL     AttemptVerticalPan ( HWND hwnd, MPARAM mp2, PVIDEOWINDOWINFO pvi ) ;
BOOL     AttemptZoom ( HWND hwnd, MPARAM mp2, PVIDEOWINDOWINFO pvi ) ;
VOID     ChangeActionMode ( PVIDEOWINDOWINFO pvi, LONG Mode ) ;
VOID     ChangeVideoWindowStyle ( PVIDEOWINDOWINFO pvi, LONG OldStyle, LONG NewStyle ) ;
VOID     CreateSourceControlDialog ( PVIDEOWINDOWINFO pvi, BOOL fShow ) ;
VOID     DisplayMessage(PCH str) ;
VOID     DisplayPassDeviceMessage ( PCH str ) ;
VOID     DisplaySourceTextValues ( HWND hwnd, PRECTL prcl ) ;
VOID     DisplayValuesInClientArea ( HPS hps, PVIDEOWINDOWINFO pvi ) ;
VOID     ExitFunction ( PSZ pszMessage, WORD wErrorCode ) ;
BOOL     FitRectInsideRect ( PRECTL prclInput, PRECTL prclResult, PRECTL prclMin, PRECTL prclMax ) ;
BOOL     FitSegmentInsideSegment ( PRECTL prclInput, PRECTL prclMin, PRECTL prclMax, PRECTL prclResult, BOOL fVertical  ) ;
VOID     InitializeVideoWindowInfo ( PVIDEOWINDOWINFO pvi, LONG VideoInput ) ;
VOID     InitializeVideoDisplayInfo ( PVIDEOWINDOWINFO pvi, LONG VideoInput ) ;
int      main( VOID );
VOID     MapReadoutToClr ( LONG Readout, PCOLOR pclr ) ;
BOOL     MakeSrcPropToNewDst ( PVIDEOWINDOWINFO pvi, LONG OldStyle, LONG NewStyle ) ;
VOID     MapInvalidRectToValidRect ( PRECTL prclCur, PRECTL prclResult, PRECTL prclMin, PRECTL prclMax, BOOL fMapX ) ;
VOID     SetChildWindowPos ( HWND hwndChild, PVIDEOWINDOWINFO pwi ) ;
VOID     SetDefaultSourceRect ( PVIDEOWINDOWINFO pvi ) ;
VOID     SetFrameWindowPos ( HWND hwndFrame, PVIDEOWINDOWINFO pwi ) ;
USHORT   SetupMyMainWindow ( PAPPLICATIONINFO pai ) ;
VOID     ToggleSourceControlDialog ( HWND hwnd, PVIDEOWINDOWINFO pvi ) ;
VOID     UpdatePanScrollBarCharacteristics ( HWND hwnd, PVIDEOWINDOWINFO pvi ) ;
VOID     UpdateSourceArea ( HWND hwnd, PVIDEOWINDOWINFO pvi ) ;
VOID     UpdateSourceZoomCharacteristics ( HWND hwnd, PVIDEOWINDOWINFO pvi ) ;
VOID     UpdateHorzStretchCharacteristics ( HWND hwnd, PVIDEOWINDOWINFO pvi ) ;
VOID     UpdateVertStretchCharacteristics ( HWND hwnd, PVIDEOWINDOWINFO pvi ) ;
VOID     SetHorizontalScrollBarPosition ( HWND hwnd, PVIDEOWINDOWINFO pvi );
VOID     SetVerticalScrollBarPosition ( HWND hwnd, PVIDEOWINDOWINFO pvi ) ;

//-----------------------------------------------------------------------------
// Function definitions for window functions...
//-----------------------------------------------------------------------------
MRESULT EXPENTRY MainWinProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY ChildWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 ) ;
MRESULT EXPENTRY ProdInfoDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY DevDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY DevHelpInfoDlgProc( HWND hwndDlg, ULONG msg, MPARAM mp1, MPARAM mp2 );
MRESULT EXPENTRY SourceControlDialogProc ( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) ;
MRESULT EXPENTRY SeekDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) ;

//***************************************************************************** */
// END OF FILE
//*****************************************************************************
