/*
/******************************************************************************/
/*                                                                            */
/* Module Name: LVDSYS.H                                                      */
/*                                                                            */
/* This file contains user defines for videodisc player drivers               */
/* LVDP6000.DLL and LVDSONY.DLL                                               */
/*                                                                            */
/* Copyright (c) International Business Machines Corporation 1992             */
/*                        All Rights Reserved                                 */
/*                                                                            */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/* Custom flags...
/*----------------------------------------------------------------------------*/
#define MCI_VD_GETDEVCAPS_CDDA              0x00001000L
#define MCI_VD_GETDEVCAPS_CDV               0x00002000L

#define MCI_VD_MEDIA_CDDA                   0x00000004L
#define MCI_VD_MEDIA_CDV                    0x00000005L

/*----------------------------------------------------------------------------*/
/* Custom return codes...                                                     */
/*----------------------------------------------------------------------------*/
#define MCIERR_VDP_NOT_PAUSED    (MCIERR_CUSTOM_DRIVER_BASE + 0 )
#define MCIERR_VDP_NOT_PLAYING   (MCIERR_CUSTOM_DRIVER_BASE + 1 )
#define MCIERR_VDP_NOCLV         (MCIERR_CUSTOM_DRIVER_BASE + 2 )
#define MCIERR_VDP_NO_LABEL      (MCIERR_CUSTOM_DRIVER_BASE + 3 )

/*----------------------------------------------------------------------------*/
/* Return values for MCI_VDP_GET_MODE                                         */
/*----------------------------------------------------------------------------*/
#define MCI_VDP_MODE_NOT_READY   ( MCI_MODE_NOT_READY )
#define MCI_VDP_MODE_PAUSE       ( MCI_MODE_PAUSE     )
#define MCI_VDP_MODE_PLAY        ( MCI_MODE_PLAY      )
#define MCI_VDP_MODE_STOP        ( MCI_MODE_STOP      )
#define MCI_VDP_MODE_SEEK        ( MCI_MODE_SEEK      )
#define MCI_VDP_MODE_DOOR_OPEN   16       /* Spun down, door open                      */
#define MCI_VDP_MODE_NO_DISC     17       /* Spun down, door closed, media not present */
#define MCI_VDP_MODE_PARKED      18       /* Spun down, door closed, media present     */
#define MCI_VDP_MODE_STILL       19       /* Like MCI_MODE_STOP but shows video        */

/*----------------------------------------------------------------------------*/
/* Custom commands...                                                         */
/*----------------------------------------------------------------------------*/
#define MCI_VDP_SET_END   ( MCI_USER_MESSAGES + 0 )
#define MCI_VDP_GET_MODE  ( MCI_USER_MESSAGES + 1 )

typedef struct {
    DWORD   dwCallback ;     // PM window handle for MCI notify message
    DWORD   dwPosition ;     // End position for videodisc
} MCI_VDP_SET_END_PARMS;
typedef MCI_VDP_SET_END_PARMS   *LPMCI_VDP_SET_END_PARMS;

typedef struct {
    DWORD   dwCallback ;     // PM window handle for MCI notify message
    DWORD   dwReturn   ;     // Logical player mode...
} MCI_VDP_GET_MODE_PARMS;
typedef MCI_VDP_GET_MODE_PARMS   *LPMCI_VDP_GET_MODE_PARMS;

/*----------------------------------------------------------------------------*/
/* End of file...                                                             */
/*----------------------------------------------------------------------------*/
