/*************************************************************************
*
*  File Name   : Vidplay.h
*
*  Description : This file contains the definitions used by the VIDPLAY
*                sample application.
*
*  Concepts    : None.
*
*  Copyright (C) 1992 IBM Corporation
*
*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
*      sample code created by IBM Corporation. This sample code is not
*      part of any standard or IBM product and is provided to you solely
*      for  the purpose of assisting you in the development of your
*      applications.  The code is provided "AS IS", without
*      warranty of any kind.  IBM shall not be liable for any damages
*      arising out of your use of the sample code, even if they have been
*      advised of the possibility of such damages.                                                    *
*
************************************************************************/


#define ID_MAINWND              1

/**************************************************/
/*********   MENU SELECTION DEFINITIONS  **********/
/**************************************************/
/* FILE Submenu */
#define IDM_FILE              100
#define IDM_LOAD                110
#define IDM_SAVE                120
#define IDM_SAVEAS              130
#define IDM_EXIT                140


/* CONTROLS Submenu */
#define IDM_CONTROLS          200
#define IDM_AUDIO               210
#define IDM_AAC_MIN_SET           211
#define IDM_AAC_COMP_SET          212
#define IDM_VIDEO               220
#define IDM_VAC_MIN_SET           221
#define IDM_VAC_COMP_SET          222
#define IDM_PLAYER              230
#define IDM_VPC_MIN_SET           231
#define IDM_VPC_COMP_SET          232
#define IDM_SHOWALL             240
#define IDM_SHOWAAC             241
#define IDM_SHOWVAC             242
#define IDM_SHOWVPC             243
#define IDM_HIDEALL             250
#define IDM_HIDEAAC             251
#define IDM_HIDEVAC             252
#define IDM_HIDEVPC             253

/* Source Submenu */
#define IDM_SOURCE            300
#define IDM_AUDIOSOURCE1        310
#define IDM_AUDIOSOURCE2        311
#define IDM_VIDEOSOURCE1        321
#define IDM_VIDEOSOURCE2        322
#define IDM_VIDEOSOURCE3        323

/* Image Submenu */
#define IDM_IMAGE             400
#define IDM_CAPTURE             410
#define IDM_RESTORE             420
#define IDM_UNFREEZE            430

#define IDM_HELP              500
#define IDM_HELPITEM            510
#define IDM_ABOUT               520

/**************************************************/

/*************************************/
/* MESSAGEBOX DIALOG BOX DEFINITIONS */
/*************************************/
#define ID_MESSAGEBOX         2000

/***********************************/
/* PRODINFO DIALOG BOX DEFINITIONS */
/***********************************/
#define ID_DLG_PRODINFO       3000
#define ID_PRODTEXT1          3001
#define ID_PRODTEXT2          3002
#define ID_PRODTEXT3          3003
#define ID_PRODBITMAP         3004

/***************************************/
/***** CONTROL RELATED DEFINITIONS *****/
/***************************************/
#define ID_AAC_WND            4000
#define ID_VAC_WND            4001
#define ID_VPC_WND            4002

#define ID_DLG_AAC            4003
#define ID_DLG_VAC            4004
#define ID_DLG_VPC            4005

#define MMCONTROLS_DLLNAME    "MMCTL"

/*******************************/
/* HELP DIALOG BOX DEFINITIONS */
/*******************************/
#define ID_HELP_INFO_DLG         5000
#define ID_HELP_LISTBOX          5100

/* String Table defines for Help Information Text */
#define NUM_HELP_LINES   32
#define         ID_HELP_TEXT_LINE_1                 5101
#define         ID_HELP_TEXT_LINE_2                 5102
#define         ID_HELP_TEXT_LINE_3                 5103
#define         ID_HELP_TEXT_LINE_4                 5104
#define         ID_HELP_TEXT_LINE_5                 5105
#define         ID_HELP_TEXT_LINE_6                 5106
#define         ID_HELP_TEXT_LINE_7                 5107
#define         ID_HELP_TEXT_LINE_8                 5108
#define         ID_HELP_TEXT_LINE_9                 5109
#define         ID_HELP_TEXT_LINE_10                5110
#define         ID_HELP_TEXT_LINE_11                5111
#define         ID_HELP_TEXT_LINE_12                5112
#define         ID_HELP_TEXT_LINE_13                5113
#define         ID_HELP_TEXT_LINE_14                5114
#define         ID_HELP_TEXT_LINE_15                5115
#define         ID_HELP_TEXT_LINE_16                5116
#define         ID_HELP_TEXT_LINE_17                5117
#define         ID_HELP_TEXT_LINE_18                5118
#define         ID_HELP_TEXT_LINE_19                5119
#define         ID_HELP_TEXT_LINE_20                5120
#define         ID_HELP_TEXT_LINE_21                5121
#define         ID_HELP_TEXT_LINE_22                5122
#define         ID_HELP_TEXT_LINE_23                5123
#define         ID_HELP_TEXT_LINE_24                5124
#define         ID_HELP_TEXT_LINE_25                5125
#define         ID_HELP_TEXT_LINE_26                5126
#define         ID_HELP_TEXT_LINE_27                5127
#define         ID_HELP_TEXT_LINE_28                5128
#define         ID_HELP_TEXT_LINE_29                5129
#define         ID_HELP_TEXT_LINE_30                5130
#define         ID_HELP_TEXT_LINE_31                5131
#define         ID_HELP_TEXT_LINE_32                5132

#ifndef MCI_VID_STATUS_TRANSPARENT_TYPE
  #define MCI_VID_STATUS_TRANSPARENT_TYPE     (MCI_VID_ITEM_BASE+23)
  #define MCI_OVLY_STATUS_TRANSPARENT_TYPE    MCI_VID_STATUS_TRANSPARENT_TYPE
#endif

#ifndef MCI_VID_STATUS_TRANSPARENT_COLOR
  #define MCI_VID_STATUS_TRANSPARENT_COLOR    (MCI_VID_ITEM_BASE+24)
  #define MCI_OVLY_STATUS_TRANSPARENT_COLOR   MCI_VID_STATUS_TRANSPARENT_COLOR
#endif

#ifndef MCI_VID_TRANSPARENT_RGB
  #define MCI_VID_TRANSPARENT_RGB             0x00000001L
  #define MCI_OVLY_TRANSPARENT_RGB            MCI_VID_TRANSPARENT_RGB
#endif

#ifndef MCI_VID_TRANSPARENT_PALINDEX
  #define MCI_VID_TRANSPARENT_PALINDEX        0x00000002L
  #define MCI_OVLY_TRANSPARENT_PALINDEX       MCI_VID_TRANSPARENT_PALINDEX
#endif
